package org.powerscala.reflect

import org.objectweb.asm.{MethodVisitor, ClassReader, Type}
import org.objectweb.asm.tree._

import scala.collection.JavaConversions._
import scala.collection.JavaConverters._

/**
 * @author Matt Hicks <mhicks@powerscala.org>
 */
object Test {
  def main(args: Array[String]): Unit = {
    val clazz = classOf[Test]
    val classLoader = clazz.getClassLoader
    val declaringType = Type.getType(clazz)
    val url = declaringType.getInternalName + ".class"
    val classNode = new ClassNode()
    val input = classLoader.getResourceAsStream(url)
    try {
      val classReader = new ClassReader(input)
      classReader.accept(classNode, 0)
    } finally {
      input.close()
    }

    val method = clazz.getMethods.find(m => m.getName == "test").get
    val desc = Type.getMethodDescriptor(method)
    val methodNode = classNode.methods.asInstanceOf[java.util.List[MethodNode]].find(m => m.name == "test" && m.desc == desc).get
    methodNode.localVariables.foreach {
      case n: LocalVariableNode => println(n.name + " / " + n.desc + " / " + n.signature + " / " + n.index)
    }
//    for (instruction <- methodNode.instructions.iterator()) instruction match {
//      case n: LabelNode => {
//        println("LabelNode: %s".format(n.getLabel.info))
//      }
//      case n: LineNumberNode => {
//        println("LineNumber: %s / %s".format(n.line, n.start.getLabel))
//      }
//      case n: InsnNode => {
//        println("InsnNode: %s".format(n.getType))
//      }
//      case n: VarInsnNode => {
//        println("VarIsnsNode: %s".format(n.`var`))
//      }
//      case n: LdcInsnNode => {
//        println(n)
//      }
//    }
  }
}

class Test {
  def test() = {
    val x = 5
    val y = "6"
  }
}